c main
	implicit none
c target center is assumed to be 3.2 cm downstream from NC center
c 	thickness = 15 cm, inner-radius = 11.75 cm
	real k_trg_cross(3), NC_proton_point(3), proton_TOF
	real p_p_input, p_p_output, dE_thin, dE_thick
	integer luni/97/, luno/98/, lunt/99/
c common
      real  M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      common /masses/ M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      real  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
      common /masses2/  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
c common for VCAVP
	real VCAVP_low, VCAVP_high
	common /VCAVP/ VCAVP_low, VCAVP_high
c
	integer evnum
	common /DBG/ evnum
c local
	real*8 M_ini, E_p, p_p, M_p_d
	real M_X, vCA_vp, p_p_input2, proton_TOF2
	logical PID_check
c begin
	evnum = 0
	call td_init
	call PID_init
	call define_masses
      call target_def
      call  td_hdef1(100, 'p_p_output - p_p_input', 'momentum (MeV/c)', 'Counts', 
     &                      360, -80., 80. )
      call  td_hdef1(108, 'p_p_input2(TOF ceonverted) - p_p_input', 'momentum (MeV/c)', 'Counts', 
     &                      360, -80., 80. )
      call  td_hdef1(109, 'p_p_output - p_p_input2(TOF ceonverted)', 'momentum (MeV/c)', 'Counts', 
     &                      360, -80., 80. )
      call  td_hdef1(107, 'p_p_input', 'momentum (MeV/c)', 'Counts', 
     &                      160, 0., 800. )
      call  td_hdef1(101, 'p_p_output', 'momentum (MeV/c)', 'Counts', 
     &                      160, 0., 800. )
      call  td_hdef1(102, 'M_X_output', 'Energy (MeV)', 'Counts', 
     &                      60, 2900., 3200. )
      call  td_hdef1(103, 'p_p_output : PID', 'momentum (MeV/c)', 'Counts', 
     &                      160, 0., 800. )
      call  td_hdef1(104, 'M_X_output : PID', 'Energy (MeV)', 'Counts', 
     &                      60, 2900., 3200. )
      call  td_hdef1(105, 'p_p_output : PID & vCA_vp', 'momentum (MeV/c)', 'Counts', 
     &                      160, 0., 800. )
      call  td_hdef1(106, 'M_X_output : PID & vCA_vp', 'Energy (MeV)', 'Counts', 
     &                      60, 2900., 3200. )
      call  td_hdef2(200, 'p_p_input vs p_p_output', 'p_p_input (MeV/c)', 'p_p_output (MeV/c)', 
     &                      80, 0., 800., 80, 0., 800. )
      call  td_hdef2(165, 'dE_thick vs dE_thin', 
     &                     'dE_thick (MeVee/30mm)', 'dE_thin (MeVee/6mm)', 
     &                      40, 0., 80., 40, 0., 20. )
      call  td_hdef2(166, 'dE_thick vs dE_thin & PID', 
     &                     'dE_thick (MeVee/30mm)', 'dE_thin (MeVee/6mm)', 
     &                      40, 0., 80., 40, 0., 20. )
      call  td_hdef1(201, 'vCA_vp', 'vCA_vp (mm)', 'Counts', 
     &                      200, -100., 100. )

      call  td_hdef1(110, 'p_p_output : -60 < vCA_vp < -25', 'momentum (MeV/c)', 'Counts', 
     &                      160, 0., 800. )
      call  td_hdef1(111, 'M_X_output : -60 < vCA_vp < -25', 'Energy (MeV)', 'Counts', 
     &                      60, 2900., 3200. )
      call  td_hdef1(112, 'p_p_output : -25 < vCA_vp < -5', 'momentum (MeV/c)', 'Counts', 
     &                      160, 0., 800. )
      call  td_hdef1(113, 'M_X_output : -25 < vCA_vp < -5', 'Energy (MeV)', 'Counts', 
     &                      60, 2900., 3200. )
      call  td_hdef1(114, 'p_p_output : -5 < vCA_vp < -0', 'momentum (MeV/c)', 'Counts', 
     &                      160, 0., 800. )
      call  td_hdef1(115, 'M_X_output : -5 < vCA_vp < -0', 'Energy (MeV)', 'Counts', 
     &                      60, 2900., 3200. )
      call  td_hdef1(116, 'p_p_output :  0 < vCA_vp < 5', 'momentum (MeV/c)', 'Counts', 
     &                      160, 0., 800. )
      call  td_hdef1(117, 'M_X_output :  0 < vCA_vp < 5', 'Energy (MeV)', 'Counts', 
     &                      60, 2900., 3200. )
      call  td_hdef1(118, 'p_p_output :  5 < vCA_vp < 25', 'momentum (MeV/c)', 'Counts', 
     &                      160, 0., 800. )
      call  td_hdef1(119, 'M_X_output :  5 < vCA_vp < 25', 'Energy (MeV)', 'Counts', 
     &                      60, 2900., 3200. )
      call  td_hdef1(120, 'p_p_output :  25 < vCA_vp < 60', 'momentum (MeV/c)', 'Counts', 
     &                      160, 0., 800. )
      call  td_hdef1(121, 'M_X_output :  25 < vCA_vp < 60', 'Energy (MeV)', 'Counts', 
     &                      60, 2900., 3200. )

      call  td_hdef1(301, 'p_p_output : outside target', 'momentum (MeV/c)', 'Counts', 
     &                      160, 0., 800. )
      call  td_hdef1(302, 'M_X_output : outside target', 'Energy (MeV)', 'Counts', 
     &                      60, 2900., 3200. )
      call  td_hdef1(401, 'p_p_input2 (TOF ceonverted)', 'momentum (MeV/c)', 'Counts', 
     &                      160, 0., 800. )
      call  td_hdef1(402, 'M_X_input2 (TOF ceonverted)', 'Energy (MeV)', 'Counts', 
     &                      60, 2900., 3200. )

	Open ( unit = luni, file = './proton-data/data.dat', status = 'old' )
	Open ( unit = luno, file = './proton-data/output_data.dat', status = 'unknown' )

	M_ini = M_helium4 + M_k
	M_p_d = M_p
	Do while (.true.)
	   read(luni, *, err = 10) k_trg_cross, NC_proton_point, proton_TOF, p_p_input, dE_thin, dE_thick, vCA_vp 
	   call proton_kin(k_trg_cross, NC_proton_point, proton_TOF, proton_TOF2, p_p_input2, p_p_output)
	      p_p = p_p_input2
	      E_p = sqrt(M_p_d**2 + p_p**2)
	      M_X = sqrt(M_ini**2 - 2.d0*M_ini*E_p + M_p_d**2)
	      call td_hf1(401, p_p_input2, 1.0)
	      call td_hf1(402, M_X, 1.0)
c	   write(*,*) '##### p_p_input, p_p_output', p_p_input, p_p_input2, p_p_output
c	   write(*,*) proton_TOF, proton_TOF2
	   if(p_p_output .gt. 20000.) then
	      p_p = p_p_output - 20000.
	      E_p = sqrt(M_p_d**2 + p_p**2)
	      M_X = sqrt(M_ini**2 - 2.d0*M_ini*E_p + M_p_d**2)
	      call td_hf1(301, p_p_output - 20000., 1.0)
	      call td_hf1(302, M_X, 1.0)
	   else
	      p_p = p_p_output
	      E_p = sqrt(M_p_d**2 + p_p**2)
	      M_X = sqrt(M_ini**2 - 2.d0*M_ini*E_p + M_p_d**2)
	   endif
c	   write(*,*) M_X, p_p, E_p
	   call td_hf2(200, p_p_input, p_p_output, 1.0)
	   call td_hf1(100, p_p_output - p_p_input, 1.0)
	   call td_hf1(108, p_p_input2 - p_p_input, 1.0)
	   call td_hf1(109, p_p_output - p_p_input2, 1.0)
	   call td_hf1(107, p_p_input, 1.0)
	   call td_hf1(101, p_p_output, 1.0)
	   call td_hf1(102, M_X, 1.0)
	   call td_hf2(165, dE_thick, dE_thin, 1.0)
	   call td_hf1(201, vCA_vp, 1.0)
	   if(vCA_vp.gt.-60. .and. vCA_vp.le.-25.) then
	         call td_hf1(110, p_p_output, 1.0)
	         call td_hf1(111, M_X, 1.0)
	   else if(vCA_vp.gt.-25. .and. vCA_vp.le.-5.) then
	         call td_hf1(112, p_p_output, 1.0)
	         call td_hf1(113, M_X, 1.0)
	   else if(vCA_vp.gt.-5. .and. vCA_vp.le.0.) then
	         call td_hf1(114, p_p_output, 1.0)
	         call td_hf1(115, M_X, 1.0)
	   else if(vCA_vp.gt.0. .and. vCA_vp.le.5.) then
	         call td_hf1(116, p_p_output, 1.0)
	         call td_hf1(117, M_X, 1.0)
	   else if(vCA_vp.gt.5. .and. vCA_vp.le.25.) then
	         call td_hf1(118, p_p_output, 1.0)
	         call td_hf1(119, M_X, 1.0)
	   else if(vCA_vp.gt.25. .and. vCA_vp.le.60.) then
	         call td_hf1(120, p_p_output, 1.0)
	         call td_hf1(121, M_X, 1.0)
	   endif
	   if(PID_check(dE_thick, dE_thin)) then
	      call td_hf2(166, dE_thick, dE_thin, 1.0)
	      call td_hf1(103, p_p_output, 1.0)
	      call td_hf1(104, M_X, 1.0)
		if(vCA_vp.gt.VCAVP_low .and. vCA_vp.le.VCAVP_high) then
	         call td_hf1(105, p_p_output, 1.0)
	         call td_hf1(106, M_X, 1.0)
	      endif
	   endif
	   write(luno,*) k_trg_cross, NC_proton_point, proton_TOF, p_p_output, dE_thin, dE_thick, vCA_vp 
	EndDo
10 	continue
	close(luno)
	close(luni)
      call  td_Hopen(lunt, './proton-data/data')
      call  td_Houtput(lunt, 100, 'new')
      call  td_Houtput(lunt, 108, 'new')
      call  td_Houtput(lunt, 109, 'new')
      call  td_Houtput(lunt, 107, 'new')
      call  td_Houtput(lunt, 101, 'new')
      call  td_Houtput(lunt, 102, 'new')
      call  td_Houtput(lunt, 103, 'new')
      call  td_Houtput(lunt, 104, 'new')
      call  td_Houtput(lunt, 105, 'new')
      call  td_Houtput(lunt, 106, 'new')
      call  td_HoutputLog(lunt, 165, 'new', 1., 10)
      call  td_HoutputLog(lunt, 166, 'new', 1., 10)
	call  PID_print(lunt)
      call  td_HoutputLog(lunt, 200, 'new', 1., 12)
      call  td_Hplot(lunt, 101, 'new')
      call  td_Hplot(lunt, 102, 'new')
      call  td_Hplot(lunt, 401, 'new')
      call  td_Hplot(lunt, 402, 'new')
      call  td_Hplot(lunt, 110, 'new')
      call  td_Hplot(lunt, 111, 'new')
      call  td_Hplot(lunt, 112, 'new')
      call  td_Hplot(lunt, 113, 'new')
      call  td_Hplot(lunt, 114, 'new')
      call  td_Hplot(lunt, 115, 'new')
      call  td_Hplot(lunt, 116, 'new')
      call  td_Hplot(lunt, 117, 'new')
      call  td_Hplot(lunt, 118, 'new')
      call  td_Hplot(lunt, 119, 'new')
      call  td_Hplot(lunt, 120, 'new')
      call  td_Hplot(lunt, 121, 'new')
      call  td_Hplot(lunt, 301, 'new')
      call  td_Hplot(lunt, 302, 'new')
      call  td_Hplot(lunt, 201, 'new')
      call  td_Hclose(lunt)
	stop
	end	





	subroutine proton_kin( k_trg_cross, NC_proton_point, proton_TOF, proton_TOF2, p_p0, p_p )
c proton energy correction 
	implicit none
	real k_trg_cross(3), NC_proton_point(3), proton_TOF, p_p, v_p(3)
	real p_flight_Length, T_p, p_p0, proton_TOF2
	real M_p /938.27231/
	integer proton /7/
	real p_guess1, p_guess2, t_guess1, t_guess2, t_err1, t_err2
	real proton_motion(3), p_new, p_guess1s, p_guess2s, t_new
	integer init, react, decay, multi, fluct, box, status1, status2
	real*8 beta
	integer j
	integer evnum
	common /DBG/ evnum
c common
	integer n_start, n_end
	common /ncount/ n_start, n_end
	integer b_start, b_end
	common /boundary/ b_start, b_end
c
	integer ncv_start, ncv_end
	common /ncv/ ncv_start, ncv_end
c
	integer hit, PID
	real dE, dL, pnt_lcl(3), v_lcl(3), p_lcl, t_lcl
	integer Target_check, BOXmap, target /3/
	real length
c
	evnum = evnum + 1
	j =0
	   v_p(1) = ( NC_proton_point(1) - k_trg_cross(1) ) 
	   v_p(2) = ( NC_proton_point(2) - k_trg_cross(2) ) 
	   v_p(3) = ( NC_proton_point(3) - k_trg_cross(3) ) 
	   p_flight_Length = sqrt( v_p(1)**2 + v_p(2)**2 + v_p(3)**2 ) 
	   v_p(1) = v_p(1) / p_flight_Length
	   v_p(2) = v_p(2) / p_flight_Length
	   v_p(3) = v_p(3) / p_flight_Length
         beta = p_flight_Length / 29.9792458 / proton_TOF
         T_p = M_p *( 1.d0 - sqrt(1.d0 - beta**2) ) / sqrt(1.d0 - beta**2) 
         p_p0 = sqrt( T_p * ( T_p + 2. * M_p ) )
	   p_guess1 = p_p0 
	   p_guess1s = p_guess1
	   p_guess2 = p_p0 + 200.
	   p_guess2s = p_guess2
         t_guess1 = 0. 
	   init  = 1
	   react = 0
	   decay = 0
	   multi = 0
	   fluct = 0
	   proton_motion(1) = k_trg_cross(1)
	   proton_motion(2) = k_trg_cross(2)
	   proton_motion(3) = k_trg_cross(3)
         Target_check = BOXmap(target,proton_motion,v_p,length)

	   p_guess1s = p_guess1
c	write(*, *) '**** evnum, proton_TOF ini', evnum, proton_TOF
cxcx
c	write(*, *) 'proton_motion, p_guess1, proton_TOF ini', proton_motion, p_guess1, proton_TOF
c	write(*, *) 'v_p ini', v_p
cxcx
	   call Travel(p_guess1,proton_motion,v_p,proton,Box,t_guess1,status1,
     &               init, react, decay, multi, fluct)
	   if(Box .ge. b_start .and. Box .le. b_end) go to 30
	   if(v_p(1).gt.0.) then
         	   call object_information(n_start, hit, dE, dL, 
     &			pnt_lcl, v_lcl, p_lcl, t_lcl, PID)
	   else
         	   call object_information(n_end, hit, dE, dL, 
     &			pnt_lcl, v_lcl, p_lcl, t_lcl, PID)
	   endif
	   if(hit .eq. 1) then
c	      write(*, *) 'Box1', Box, n_start, hit, t_guess1, p_guess1s, p_guess1, t_lcl     
		t_guess1 = t_lcl
c	   else
c	      write(*, *) 'Box1', Box, n_start, hit, t_guess1, p_guess1s, p_guess1
	   endif
         t_err1 = t_guess1 - proton_TOF 
10	continue
	   j = j + 1
	   init  = 1
         t_guess2 = 0. 
	   p_guess2s = p_guess2
	   proton_motion(1) = k_trg_cross(1)
	   proton_motion(2) = k_trg_cross(2)
	   proton_motion(3) = k_trg_cross(3)
	   call Travel(p_guess2,proton_motion,v_p,proton,Box,t_guess2,status2,
     &               init, react, decay, multi, fluct)
	   if(v_p(1).gt.0.) then
         	   call object_information(n_start, hit, dE, dL, 
     &			pnt_lcl, v_lcl, p_lcl, t_lcl, PID)
	   else
         	   call object_information(n_end, hit, dE, dL, 
     &			pnt_lcl, v_lcl, p_lcl, t_lcl, PID)
	   endif
	   if(hit .eq. 1) then
c	      write(*, *) 'Box2', Box, t_guess2, p_guess2s, p_guess2, t_lcl     
		t_guess2 = t_lcl
c	   else
c	      write(*, *) 'Box2', Box, t_guess2, p_guess2s, p_guess2
	   endif
         t_err2 = t_guess2 - proton_TOF 
c	   write(*,*) 'j, p_guess1s, p_guess2s',j, p_guess1s, t_err1, p_guess2s, t_err2
	   p_new = (t_err2*p_guess1s - t_err1*p_guess2s) / (t_err2 - t_err1)
	if(p_new.lt.300.) p_new = 300.
cxcx
c	if(p_p_org .lt. 390.) then
c	write(*, *) j, p_guess1s, p_guess2s,t_err1,t_err2, status1,status2
c     &	, p_new
c	endif
cxcx
	   if(j.gt.3 .and.(abs(p_new-p_guess1s) .lt. 0.01 .or. abs(p_new-p_guess2s) .lt. 0.01)) go to 20
	   if(abs(p_new-p_guess1s).lt. 0.005) p_new = p_guess1s - 0.005
	   if(abs(p_new-p_guess2s).lt. 0.005) p_new = p_guess2s - 0.005
c	   write(*, *) 'p_new', p_new
	   if(abs(p_new-p_guess2s) .lt. abs(p_new-p_guess1s)) then
		p_guess1s = p_guess2s
		t_err1 = t_err2
		p_guess2 = p_new
	      if(j.gt.20) go to 25
		go to 10
	   else
		p_guess2 = p_new
	      if(j.gt.20) go to 25
		go to 10
	   endif
20	continue
	   if(Box .ge. b_start .and. Box .le. b_end) go to 30
	   p_p = p_new
	   t_new = 0.
	   proton_motion(1) = k_trg_cross(1)
	   proton_motion(2) = k_trg_cross(2)
	   proton_motion(3) = k_trg_cross(3)
	   call Travel(p_new,proton_motion,v_p,proton,Box,t_new,status2,
     &               init, react, decay, multi, fluct)
	   if(v_p(1).gt.0.) then
         	   call object_information(n_start, hit, dE, dL, 
     &			pnt_lcl, v_lcl, p_lcl, t_lcl, PID)
	   else
         	   call object_information(n_end, hit, dE, dL, 
     &			pnt_lcl, v_lcl, p_lcl, t_lcl, PID)
	   endif
	   proton_TOF2 = t_new
	   if(hit .eq. 1) then
		proton_TOF2 = t_lcl
	   endif
	   if(p_new .ge. 10000. .or. hit .ne. 1) go to 25
	   if(t_err1 .ge. 0.1) go to 25
	   if(Target_check .ne. 1) go to 27
	return
25	continue
	   p_p = p_new + 10000.
	   if(p_p.ge.20000.) p_p = -10000.
	return
27	continue
	   p_p = p_new + 20000.
	   if(p_p.ge.30000.) p_p = -10000.
	return
30	continue
	   p_p = -10000.
	return
	end





      subroutine define_masses
      implicit NONE
c common block
c mass and particle ID in this routine
      real  M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      common /masses/ M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      real  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
      common /masses2/  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c produced particle stack
      real p_stack(8,100)
      integer pid_stack(100), rid_stack(100), stack
      common /STK/ p_stack, pid_stack, rid_stack, stack
c ... common /RIDS/ reaction ID
	integer KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
	common /RIDS/ KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
c data for mass
      real Atomic_Mass / 931.494013 /
      data M_k / 493.677/, M_p / 938.27231/, M_n / 939.56563/ 
      data M_L / 1115.683/, M_pi / 139.56995/, M_pi0 /134.9764/
      data M_Sp / 1189.34/, M_S0 / 1192.642/, M_Sm / 1197.449/ 
      data  M_nn       / 1879.13126 / ! 2 neutron
      data  PID_pion /2/, PID_pi0 /3/, PID_proton /7/, PID_neutron /8/, 
     &            PID_Lambda /9/,   PID_SigmaP /10/, PID_SigmaM /-11/,
     &            PID_Sigma0 /12/,  PID_deuteron /14/, PID_triton /15/, 
     &		PID_helium3 /16/
c data for PIDS
	data KN /1/, tnL /2/, tnS /3/, pi_abs /4/, SLc /5/, QFL /6/, QFS /7/, pi_mono /8/
	data CBG /8/
c
	M_helium4 = 4 * Atomic_Mass + 2.424911  - 2 * 0.510998902
	M_helium3 = 3 * Atomic_Mass + 14.931204 - 2 * 0.510998902
	M_triton    = 3 * Atomic_Mass + 14.949794- 1 *  0.510998902
	M_deuteron = 2 * Atomic_Mass + 13.135720 - 1 *  0.510998902
      return
      end





 	logical function area_check(x, y, boundary, N)
      implicit NONE
c input
	real x, y, boundary(5, 20)
	integer N
c local
	integer count, j
	real vr, wv, s, t
	real r(2), v(2), ar(2), vwv(2), vww(2)
	real x0 /0./, y0 /0./
c begin
	r(1) = x0
	r(2) = y0
	v(1) = x - x0
	v(2) = y - y0
	vr = sqrt( v(1)**2 + v(2)**2 )
	v(1) = v(1) / vr
	v(2) = v(2) / vr
	count = 0
c	write(*,*) '### r, v ', r(1), r(2), v(1), v(2)
	Do j = 1, N
	   ar(1) = boundary(1, j) - r(1)
	   ar(2) = boundary(2, j) - r(2) 
	   wv = v(1) * boundary(3, j) + v(2) * boundary(4, j)
	   if( 1. - wv**2 .ne. 0.) then
	      vwv(1) = v(1) - wv * boundary(3, j) 
	      vwv(2) = v(2) - wv * boundary(4, j)
	      t =  ( ar(1) * vwv(1) + ar(2) * vwv(2) ) / ( 1. - wv**2 )
	      vww(1) = boundary(3, j) - wv * v(1)
	      vww(2) = boundary(4, j) - wv * v(2)
	      s =  - ( ar(1) * vww(1) + ar(2) * vww(2) ) / ( 1. - wv**2 )
c	write(*,*) 'j:  a, w ', j, ' :', boundary(1, j), boundary(2, j), boundary(3, j), boundary(4, j)
c	write(*,*) '    0<t<vr, 0<s< wa      - ', '0<',t,' <', vr, ':   0<',s,' <', boundary(5, j)
	      if( s.lt.boundary(5, j) .and. t.lt.vr
     &	   .and. t.ge.0. .and. s.gt.0. ) then
c	write(*,*) ' hit!!'
     		   count = count + 1
     		endif
     	   endif
	enddo
c	write(*,*) 'count = ', count
	count = count - int(count/2)*2
	if(count .eq. 1) then
	   area_check = .true.
c	write(*,*) '### This point is inside the boundary!'
	else
	   area_check = .false.
	endif
	return
	end
		
		
		
	logical function PID_check(x, y)
      implicit NONE
c input
	real x, y
c common for BNDRY
	real boundary(5, 50)
	integer Boundary_N
	common /BNDRY/ Boundary_N, boundary
c external
	logical area_check
c begin
	PID_check = area_check(x, y, boundary, Boundary_N)
	return
	end
			
			
			
			
	
	subroutine PID_init
      implicit NONE
c local
	integer j
	integer lunb /96/
c common for VCAVP
	real VCAVP_low, VCAVP_high
	common /VCAVP/ VCAVP_low, VCAVP_high
c common for BNDRY
	real boundary(5, 50)
	integer Boundary_N
	common /BNDRY/ Boundary_N, boundary
c begin
	Open ( unit = lunb, file = './boundary.dat', status = 'old' )
	read(lunb,*) VCAVP_low, VCAVP_high
	read(lunb,*) Boundary_N 
	Do j = 1, Boundary_N
	   read(lunb,*) boundary(1, j), boundary(2, j)
	EndDo
	Do j = 1, Boundary_N - 1
		boundary(3, j) = boundary(1, j+1) - boundary(1, j)
		boundary(4, j) = boundary(2, j+1) - boundary(2, j)
		boundary(5, j) = sqrt( boundary(3, j)**2 + boundary(4, j)**2 ) 
		boundary(3, j) = boundary(3, j) / boundary(5, j)
		boundary(4, j) = boundary(4, j) / boundary(5, j)
	EndDo
	boundary(3, Boundary_N) = boundary(1, 1) - boundary(1, Boundary_N)
	boundary(4, Boundary_N) = boundary(2, 1) - boundary(2, Boundary_N)
	boundary(5, Boundary_N) = sqrt( boundary(3, j)**2 + boundary(4, j)**2 ) 
	boundary(3, Boundary_N) = boundary(3, Boundary_N) / boundary(5, Boundary_N)
	boundary(4, Boundary_N) = boundary(4, Boundary_N) / boundary(5, Boundary_N)
	close(lunb)
	return
	end
		





	subroutine  PID_print(lun)
	implicit none
	integer lun
c common for BNDRY
	real boundary(5, 50)
	integer Boundary_N
	common /BNDRY/ Boundary_N, boundary
c local
	integer j
c begin
	Do j = 1, Boundary_N
	   write(lun, *) boundary(1, j), boundary(2, j)
	enddo
	write(lun, *) boundary(1, 1), boundary(2, 1)
	write(lun, *) ' join 1 dash'
	return
	end





